let chronometer title f x =
  let beg = Unix.gettimeofday() in
  try 
    let ret = f x in
    flush stdout;
    let s = (Unix.gettimeofday()) -. beg in
    Printf.fprintf stderr 
      "Time spent in %s: %f s (%i h %i mn %i s)\n"
      title s (int_of_float s/3600) ((int_of_float s/60) mod 60) 
      (int_of_float s mod 60);
    flush stderr;
    ret
  with r ->
    flush stdout;
    let s = (Unix.gettimeofday()) -. beg in
    Printf.fprintf stderr 
      "Time spent in %s (interrupted): %f s (%i h %i mn %i s)\n" 
      title s (int_of_float s/3600) ((int_of_float s/60) mod 60) 
      (int_of_float s mod 60);
    flush stderr;
    raise r
