#include <caml/mlvalues.h>
#include <caml/memory.h>
#include <caml/fail.h>
#include <caml/alloc.h>

#include <float.h>
#include <stdio.h>

#define DOUBLE(name, operator)\
  double ml_double_precision_##name##_float(double a, double b)\
  {						\
    return ((double) (a operator b));		\
  }\
  \
  value ml_double_precision_##name(value a, value b)\
  {						\
    double al, bl;                              \
    CAMLparam2(a, b);                           \
    CAMLreturn(copy_double((double)              \
      (Double_val(a) operator Double_val(b)))); \
  }


DOUBLE(add, +)
DOUBLE(sub, -)
DOUBLE(mul, *)
DOUBLE(div, /)

value ml_double_precision_float_of_int(value v)
{
  CAMLparam0();
  CAMLreturn(copy_double((double) (Int_val(v))));
}

value ml_double_precision_round(value v)
{
  CAMLparam1(v);
  CAMLreturn(copy_double((double) (Double_val(v))));
}

double ml_double_precision_round_float(double v)
{
  return (double) v;
}

value ml_double_precision_to_string(value p, value f)
{
  CAMLparam2(p,f);
  char buf[1024];
  /* add 0. to transform -0 into +0 */
  snprintf(buf,sizeof(buf),"%.*g",(int)Int_val(p),0.+Double_val(f));
  buf[sizeof(buf)-1] = 0;
  CAMLreturn(copy_string(buf));
}
