#include <caml/mlvalues.h>
#include <caml/memory.h>
#include <caml/fail.h>
#include <caml/alloc.h>

#include <float.h>

#define SINGLE(name, operator)\
  double ml_single_precision_##name##_float(double a, double b)\
  {						\
    return ((float) (a operator b));		\
  }\
  \
  value ml_single_precision_##name(value a, value b)\
  {						\
    double al, bl;                              \
    CAMLparam2(a, b);                           \
    CAMLreturn(copy_double((float)              \
      (Double_val(a) operator Double_val(b)))); \
  }


SINGLE(add, +)
SINGLE(sub, -)
SINGLE(mul, *)
SINGLE(div, /)

value ml_single_precision_float_of_int(value v)
{
  CAMLparam0();
  CAMLreturn(copy_double((float) (Int_val(v))));
}

value ml_single_precision_round(value v)
{
  CAMLparam1(v);
  CAMLreturn(copy_double((float) (Double_val(v))));
}

double ml_single_precision_round_float(double v)
{
  return (float) v;
}
