let safe_dup2 a b =
  if a=b
  then ()
  else Unix.dup2 a b;;

let pipe_through_out program cmdline out_channel work =
  flush out_channel;
  let (read_end, write_end)= Unix.pipe () in
  match Unix.fork () with
    0 ->
      (Unix.close write_end;
       Unix.dup2 read_end Unix.stdin;
       Unix.close read_end;
       safe_dup2 (Unix.descr_of_out_channel out_channel) Unix.stdout;
       (*close_out out_channel;*)
       Unix.execvp program cmdline )
  | sub_pid ->
      (Unix.close read_end;
       let write_channel = Unix.out_channel_of_descr write_end in
       work write_channel;
       close_out write_channel;
       match Unix.waitpid [] sub_pid with
	 sub_pid', (Unix.WEXITED 0) when sub_pid' = sub_pid -> ()
       | _ -> failwith "forked waitpid return code error");;


let pipe_through_in program cmdline in_channel work =
  let (read_end, write_end)= Unix.pipe () in
  match Unix.fork () with
    0 ->
      (Unix.close read_end;
       Unix.dup2 write_end Unix.stdout;
       Unix.close write_end;
       safe_dup2 (Unix.descr_of_in_channel in_channel) Unix.stdin;
       (*close_in in_channel;*)
       Unix.execvp program cmdline;
       failwith "execvp returned")
  | sub_pid ->
      (Unix.close write_end;
       let read_channel = Unix.in_channel_of_descr read_end in
       let ret = work read_channel in
       close_in read_channel;
        match Unix.waitpid [] sub_pid with
	 sub_pid', (Unix.WEXITED 0) when sub_pid' = sub_pid -> ret
       | _ -> failwith "forked waitpid return code error");;
