(**
Advanced process piping primitives
@author David Monniaux
*)

(*
Copyright (c) 2004 David Monniaux,
CNRS / Laboratoire d'informatique de l'Ecole normale superieure
*)

(** [pipe_through_out program cmdline out_channel work] will run [work pipe_channel] such that [program] is run with command line [cmdline] with standard input piped from [pipe_channel] and standard output directed into [out_channel]. *)

val pipe_through_out : string -> string array -> out_channel -> (out_channel -> unit) -> unit

(** [pipe_through_in program cmdline out_channel work] will run [work pipe_channel] such that [program] is run with command line [cmdline] with standard output piped into [pipe_channel] and standard input directed from [out_channel]; the return of the [work] function is then returned. *)

val pipe_through_in : string -> string array -> in_channel -> (in_channel -> 'a) -> 'a
